

```shell
xcodebuild：
//执行查看
$ xcodebuild -list

//执行Build指定
$ xcodebuild -workspace Project.xcworkspace -scheme Project

//执行Showsdks
$ xcodebuild -showsdks

//执行清理
$ xcodebuild -workspace Project.xcworkspace -scheme Project clean

//执行Build
$ xcodebuild -scheme Project -workspace Project.xcworkspace -sdk iphonesimulator -destination 'platform=iOS Simulator,name=iPhone 12 Pro Max' -configuration Debug
```

```shell
xcpretty 格式化

-r, --report 指定生成的报告格式可选为junit, html, json-compilation-database。
-o, --output指定生成的文件名称。
这里我们使用json-compilation-database格式，输出文件名为compile_commands.json
（注意输出名称不能更改，否则后面oclint会报错，因为oclint源码中内置了校验名称，具体可查看源码）
//安装
$ gem install xcpretty
//用法
$ xcodebuild [flags] | xcpretty
//结合tee
$ xcodebuild [flags] | tee xcodebuild.log | xcpretty
///执行完整命令生成compile_commands.json文件
$ xcodebuild -scheme Project -workspace Project.xcworkspace -sdk iphonesimulator -destination 'platform=iOS Simulator,name=iPhone 12 Pro Max' -configuration Debug GCC_PRECOMPILE_PREFIX_HEADER=YES CLANG_ENABLE_MODULE_DEBUGGING=NO COMPILER_INDEX_STORE_ENABLE=NO OTHER_CFLAGS="-DNS_FORMAT_ARGUMENT(A)= -D_Nullable_result=_Nullable" | tee xcodebuild.log | xcpretty -r json-compilation-database -o compile_commands.json

```

```shell
OCLint 是基于 Clang Tooling 开发的静态分析工具,主要用来发现编译器检查不到的那些潜在的关键技术问题。是进行OC代码分析的核心工具，主要对上一步生成的compile_commands.json进行分析，生成报告
//安装
$ brew tap oclint/formulae
$ brew install oclint
我建议使用安装包来安装OCLint,Homebrew 安装只能安装到20.11版本，最新Xcode 版本对应的是22.02。如果安装版本不符合，OClint分析出来只有一堆compiler error。
//安装包地址：https://github.com/oclint/oclint/releases

//配置环境变量：
export PATH="/Users/csdn/oclint-22.02/bin:$PATH"
source ~/.zshrc
//验证是否安装成功
$ oclint --version
//如果我们使用.oclint最终我们将.oclint放在与compile_commands.json相同的路径下，并在该路径下执行命令
$ oclint-json-compilation-database -v -e Pods
//或者生成oclint.xml
$ oclint-json-compilation-database -e Pods -- -report-type pmd \
    -rc=LONG_CLASS=1500 \
    -rc=NESTED_BLOCK_DEPTH=5 \
    -rc=LONG_VARIABLE_NAME=80 \
    -rc=LONG_METHOD=200 \
    -rc=LONG_LINE=300 \
    -disable-rule ShortVariableName \
    -disable-rule ObjCAssignIvarOutsideAccessors \
    -disable-rule AssignIvarOutsideAccessors \
    -allow-duplicated-violations=false\
    -max-priority-1=100000 \
    -max-priority-2=100000 \
    -max-priority-3=100000 >> oclint.xml

```

```shell
Infer 代码扫描软件
//安装
$ brew install infer
//验证
$ infer --version
//Infer与OCLint一样，都是分析compile_commands.json文件。在compile_commands.json文件相同路径下执行命令：
# --skip-analysis-in-path 是忽略扫描目录
$ infer run --skip-analysis-in-path Pods --keep-going --compilation-database compile_commands.json

注意：命令中一定要有--keep-going 不然会有错误导致无法进行分析。
另外需要在xcodebuild命令中添加OTHER_CFLAGS="-DNS_FORMAT_ARGUMENT(A)= -D_Nullable_result=_Nullable"。

```

```shell
sonarqube 代码静态分析平台
sonarqube是一个提供代码静态分析的平台，提供了一套完整的静态分析方案，包括后端及前端页面，可以结合jenkins、gitlab等平台来进行代码分析。sonarqube分社区版本和商业化版本,能扫描多种语言并且开源。官网地址。
因为其底层源码为java开发的，所以对java代码支持比较完善，但是免费的社区版并不支持OC，所以我们如果要借助此平台的话，有以下两种方式：

开源插件sonar-swift

，支持Objective-C和Swift / Java，支持导入 SwiftLint、Infer、OCLint、Lizard、Fauxpas 工具的扫描分析结果。最新v1.6版本，兼容SonarQube 8.9LTS版本。该插件是好未来研发团队研发并且开源。

付费使用社区版plus，提供了SonarCFamily for C插件
sonar-swift https://github.com/sonar-next/sonar-swift
通过GitHub 下载对应插件 image 下载插件放到/extensions/plugins 目录下。重启sonarqube服务，就可以了。
sonar-scanner 用来扫描本地代码,并且上传到SonarQube平台中。
//配置环境变量
$ vim ~/.bash_profile

#sonar-scanner for cli
export PATH=$PATH:/Users/csdn/scanner/bin:$PATH

$ source ~/.bash_profile

//sonar-scanner 分为两种使用方式:

//配置文件方式:
//在需要扫描项目根目录下新建sonar-project.properties 文件，内容如下:
sonar.projectKey=Project
sonar.projectName=Project
sonar.language=objc
sonar.sources=/Users/csdn/.jenkins/workspace/csdn_build_ios/
sonar.objectivec.workspace=Project.xcworkspace
sonar.objectivec.appScheme=Project
sonar.sourceEncoding=UTF-8
sonar.junit.reportsPath=sonar-reports/
sonar.objectivec.oclint.report=sonar-reports/oclint.xml
sonar.swift.infer.report=infer-out/report.json

进入项目根目录下，然后输入sonar-scanner命令，执行代码分析。


//命令行方式:
$ sonar-scanner -Dsonar.projectKey=Project -Dsonar.projectName=Project -Dsonar.projectName=Project -Dsonar.projectVersion=5.1.0 
//忽略指定文件目录或者文件
sonar.exclusions=**/Resource/**,**/*.py
//或者可以在命令中设置参数，例如：
sonar-scanner -Dsonar.exclusions=**/Resource/**,**/*.py  -Dsonar.projectKey=Project -Dsonar.projectName=Project -Dsonar.projectName=Project -Dsonar.projectVersion=5.1.0 
这里的核心便是在上面步骤中由OCLint生成的oclint.xml文件与Infer生成的report.json，另外注意oclint.xml必须放至sonar-reports文件下。report.json在Infer生成的infer-out目录下。


```

```shell
Jekins
//构建Shell命令中，增加OCLint相关命令
if [ "$MODE"x = "OCLint"x ]
then
    sh /Users/csdn/.jenkins/workspace/csdn_build_ios/fastlane/oclint.sh "$GIT_BRANCH"
fi

```



```shell
oclint.sh
#!/bin/bash

COLOR_ERR="\033[1;31m"    #出错提示
COLOR_SUCC="\033[0;32m"  #成功提示
COLOR_QS="\033[1;37m"  #问题颜色
COLOR_AW="\033[0;37m"  #答案提示
COLOR_END="\033[1;34m"     #颜色结束符



# 寻找项目的 ProjectName
function searchProjectName () {
    # maxdepth 查找文件夹的深度
    find . -maxdepth 1 -name "*.xcodeproj"
}

function oclintForProject () {
    # 预先检测所需的安装包是否存在
    if which xcodebuild 2>/dev/null; then
    echo 'xcodebuild exist'
    else
    echo 'xcodebuild 未安装，请安装Xcode'
    fi
    
    if which oclint 2>/dev/null; then
    echo 'oclint exist'
    else
    echo 'oclint 未安装，请安装OCLint'
    fi
    if which xcpretty 2>/dev/null; then
    echo 'xcpretty exist'
    else
    gem install xcpretty
    fi
    
    
    # 指定编码
    export LANG="zh_CN.UTF-8"
    export LC_COLLATE="zh_CN.UTF-8"
    export LC_CTYPE="zh_CN.UTF-8"
    export LC_MESSAGES="zh_CN.UTF-8"
    export LC_MONETARY="zh_CN.UTF-8"
    export LC_NUMERIC="zh_CN.UTF-8"
    export LC_TIME="zh_CN.UTF-8"
    export xcpretty=/usr/local/bin/xcpretty # xcpretty 的安装位置可以在终端用 which xcpretty找到
    
    searchFunctionName=`searchProjectName`
    path=${searchFunctionName}
    # 字符串替换函数。//表示全局替换 /表示匹配到的第一个结果替换。
    path=${path//.\//}  # ./BridgeLabiPhone.xcodeproj -> BridgeLabiPhone.xcodeproj
    path=${path//.xcodeproj/} # BridgeLabiPhone.xcodeproj -> BridgeLabiPhone
    
    myworkspace=$path".xcworkspace" # workspace名字
    myscheme=$path  # scheme名字
    
    # 清除上次编译数据
    if [ -d ./derivedData ]; then
    echo -e $COLOR_SUCC'-----清除上次编译数据derivedData-----'$COLOR_SUCC
    rm -rf ./derivedData
    fi
    
    # xcodebuild clean
    xcodebuild -scheme $myscheme -workspace $myworkspace clean


    # # 生成编译数据
    xcodebuild -scheme $myscheme -workspace $myworkspace -sdk iphonesimulator -destination 'platform=iOS Simulator,name=iPhone 12 Pro Max' -configuration Debug GCC_PRECOMPILE_PREFIX_HEADER=YES CLANG_ENABLE_MODULE_DEBUGGING=NO COMPILER_INDEX_STORE_ENABLE=NO OTHER_CFLAGS="-DNS_FORMAT_ARGUMENT(A)= -D_Nullable_result=_Nullable" | tee xcodebuild.log | xcpretty -r json-compilation-database -o compile_commands.json

    if [ -f ./compile_commands.json ]; then
    echo -e $COLOR_SUCC'编译数据生成完毕'$COLOR_SUCC
    else
    echo -e $COLOR_ERR'编译数据生成失败'$COLOR_ERR
    return -1
    fi

    echo -e $COLOR_SUCC'OCLint代码分析开始'$COLOR_SUCC
    # 生成报表
    oclint-json-compilation-database -e Pods -- -report-type pmd \
    -rc=LONG_CLASS=1500 \
    -rc=NESTED_BLOCK_DEPTH=5 \
    -rc=LONG_VARIABLE_NAME=80 \
    -rc=LONG_METHOD=200 \
    -rc=LONG_LINE=300 \
    -disable-rule ShortVariableName \
    -disable-rule ObjCAssignIvarOutsideAccessors \
    -disable-rule AssignIvarOutsideAccessors \
    -allow-duplicated-violations=false\
    -max-priority-1=100000 \
    -max-priority-2=100000 \
    -max-priority-3=100000 >> oclint.xml
    
    echo -e $COLOR_SUCC'Infer代码分析开始'$COLOR_SUCC
    # --skip-analysis-in-path 是忽略扫描目录
    infer run --skip-analysis-in-path Pods --keep-going --compilation-database compile_commands.json
    
    product_name=`sed -n '/PRODUCT_NAME/{s/PRODUCT_NAME = //;s/;//;s/^[[:space:]]*//;s/\"//g;p;q;}' ./$myscheme.xcodeproj/project.pbxproj`
    version_number=`sed -n '/MARKETING_VERSION/{s/MARKETING_VERSION = //;s/;//;s/^[[:space:]]*//;s/\"//g;p;q;}' ./$myscheme.xcodeproj/project.pbxproj`
    
    if [ -f ./oclint.xml -a -f ./infer-out/report.json ]; then
    rm compile_commands.json
    echo -e $COLOR_SUCC'代码分析完毕'$COLOR_SUCC
    
    mv oclint.xml sonar-reports/
    
    echo -e $COLOR_SUCC'移动至sonar-reports完毕'$COLOR_SUCC
    echo -e $COLOR_SUCC'开始执行sonar-scanner扫描文件'$COLOR_SUCC
    
    
    
    echo -e $COLOR_SUCC'版本号:'${version_number}''$COLOR_SUCC
    
    sonar-scanner  -Dsonar.projectVersion=$version_number
    
    else
    
    echo -e $COLOR_ERR'分析失败'$COLOR_ERR

    fi
       
}

oclintForProject $1


```

